import java.awt.Button;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;

public class ArrayFrameH extends JFrame implements ActionListener {
    private JButton mischenButton;
    private JButton teilmengenButton;

    private JTextArea ausgabeBereich;

    /**
     * In diesem Programmstück wird das Fenster erzeugt
     */
    public ArrayFrameH() {
        /* In der Kopfleiste des Fenster steht "ArrayFrame" */
        this.setTitle("ArrayFrame");

        /* Das Fenster ist 500 Pixel breit und 200 Pixel hoch. */
        this.setSize(500, 200);

        /* Hier werden alle Buttons erzeugt. */
        this.mischenButton = new JButton("Zwei Arrays mischen");
        this.teilmengenButton = new JButton(
                "Teilmengentest");

        /* Hier wird der Ausgabe-Bereich erzeugt. */
        this.ausgabeBereich = new JTextArea(10, 100);

        /* Hier werden alle Buttons zusammengruppiert. */
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new GridLayout(2, 1));
        buttonPanel.add(this.mischenButton);
        buttonPanel.add(this.teilmengenButton);

        /*
         * Der ContentPane ist der Ausschnitt des Fensters, auf dem Widgets d.h.
         * Interaktionselemente (wie eine TextArea oder ein Button) platziert
         * werden können.
         */
        Container contentPane = this.getContentPane();
        contentPane.setLayout(new GridLayout(2, 1));
        /* Hier wird die Gruppe von Buttons platziert. */
        contentPane.add(buttonPanel);
        /* Hier wird der Ausgabebereich platziert. */
        contentPane.add(this.ausgabeBereich);

        /*
         * Hier wird der ArrayFrame als Listener für Knopfdruck-Ereignisse bei
         * jedem der Buttons registriert.
         */
        this.mischenButton.addActionListener(this);
        this.teilmengenButton.addActionListener(this);

        /*
         * Wird das Fenster geschlossen (d.h. auf X gedrückt), wird mit Hilfe
         * dieser Programmzeile auch unser Programm ordnungsgemäß beendet.
         */
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        // je nach Button entsprechende Methode ausführen
        Object source = e.getSource();
        if (source == this.mischenButton) {
            this.mischen();
        }
        else if (source == this.teilmengenButton) {
            this.teilmenge();
        }
    }

    /**
     * implementiert die Funktionalität des Mischenbuttons
     */
    private void mischen() {
        String einlesenArray1 = JOptionPane
                .showInputDialog("Erstes Array: ");
        int[] array1 = Konverter
                .konvertiereZuIntArray(einlesenArray1);

        String einlesenArray2 = JOptionPane
                .showInputDialog("Zweites Array: ");
        int[] array2 = Konverter
                .konvertiereZuIntArray(einlesenArray2);

        String eingabe = "Erstes Array: " + einlesenArray1 + "\n";
        eingabe = eingabe + "Zweites Array: " + einlesenArray2
                + "\n\n";

        int[] reissverschluss = new int[array1.length + array2.length];

        for (int i = 0; i < reissverschluss.length; i++) {
            if (i % 2 == 0) {
                reissverschluss[i] = array1[i / 2];
            }
            else {
                reissverschluss[i] = array2[(i - 1) / 2];
            }
        }

        String ergebnis = eingabe + "Das gemischte Array ist: "
                + Konverter.konvertiereZuString(reissverschluss);

        this.ausgabeBereich.setText(ergebnis);
    }

    /**
     * implementiert die Funktionaliät des Teilmengentest-Buttons
     */
    private void teilmenge() {
        String einlesenArrayA = JOptionPane
                .showInputDialog("Erstes Array: ");
        int[] arrayA = Konverter
                .konvertiereZuIntArray(einlesenArrayA);

        String einlesenArrayB = JOptionPane
                .showInputDialog("Zweites Array: ");
        int[] arrayB = Konverter
                .konvertiereZuIntArray(einlesenArrayB);

        String eingabe = "Erstes Array: " + einlesenArrayA + "\n";
        eingabe = eingabe + "Zweites Array: " + einlesenArrayB
                + "\n\n";

        boolean istTeilmenge = this.istTeilmenge(arrayA, arrayB);

        String ergebnis = eingabe;
        if (istTeilmenge) {
            ergebnis = eingabe
                    + "Das erste Array ist Teilmenge des zweiten Arrays.";

        }
        else {
            ergebnis = eingabe
                    + "Das erste Array ist nicht Teilmenge des zweiten Arrays.";
        }
        this.ausgabeBereich.setText(ergebnis);
    }

    /**
     * testet, ob zwei Arrays die selben Elemente enthalten
     * 
     * @param arrayA
     * @param arrayB
     * @return
     */
    private boolean istTeilmenge(int[] arrayA, int[] arrayB) {
        for (int i = 0; i < arrayA.length; i++) {
            boolean gefunden = false;
            for (int j = 0; j < arrayB.length; j++) {
                if (arrayA[i] == arrayB[j]) {
                    gefunden = true;
                }
            }
            if (!gefunden) {
                return false;
            }
        }
        return true;
    }
}
